const moment = require('moment')
const crypto = require('crypto')
const axios = require('axios')
const qs = require('qs')
const fs = require('fs')
const path = require('path')
const API_BASE = 'http://uat.quickprs.com/api/json'

function encodeDesECB(textToEncode) {
  let keyString = 'B2Ckeynecarescom'
  var iv = Buffer.alloc(8)
  iv.fill(0)
  const cipher = crypto.createCipheriv('des-cbc', keyString.substr(0, 8), iv)
  let encrypted = cipher.update(textToEncode, 'utf8', 'base64')
  encrypted += cipher.final('base64')
  return encrypted
}

function sha(str) {
  const crypto = require('crypto')
  const hmac = crypto.createHmac('sha256', 'B2Ckeynecarescom')
  hmac.update(str)
  return hmac.digest('base64')
}

function decipher(str) {
  let key = 'B2Ckeynecarescom'
  var iv = Buffer.alloc(8)
  iv.fill(0)
  var decipher = crypto.createDecipheriv('des-cbc', key.substr(0, 8), iv)
  var dec = decipher.update(str, 'base64', 'utf8')
  dec += decipher.final('utf8')
  return dec
}

module.exports = async function({ req }) {
  let config = JSON.parse(fs.readFileSync(path.join(__dirname, 'config.json'), 'utf8'))
  const authAppID = config.AuthAppID
  const authTktdeptid = config.AuthTktdeptid
  const version = config.Version
  let { serviceName, data } = req.body
  let cookies = req.cookies || {}
  let xmlstr = encodeURIComponent(JSON.stringify(data))
  let clientIp = req.headers['x-forwarded-for'] || req.connection.remoteAddress
  let userId = cookies.user_id ? cookies.user_id : 'ANONYMOUS'
  let params = {
    Timestamp: moment().format('YYYYMMDDHHmmssSSS'),
    ServiceName: serviceName,
    Language: cookies._lang || 'en_US',
    TimeZone: cookies._timezone || '+08:00',
    AuthUserID: userId,
    ClientIP: clientIp,
    ReqXML: xmlstr,
    AuthAppID: authAppID,
    AuthTktdeptid: authTktdeptid,
    Version: version
  }
  let strToSign = `${params.AuthAppID}|${params.AuthUserID}|${params.ServiceName}|${params.Language}|WEB|${params.Timestamp}|${params.ReqXML}|${
    params.Version
  }|${clientIp}`
  let sign = sha(strToSign)
  params.Sign = sign
  for (let key in params) {
    if (params[key]) params[key] = encodeDesECB(params[key])
  }
  // console.log(params)
  const options = {
    method: 'POST',
    headers: {
      'content-type': 'application/x-www-form-urlencoded'
    },
    data: qs.stringify(params),
    url: API_BASE
  }
  let result = await axios(options)
  let json = JSON.parse(decipher(decodeURIComponent(result.data)))
  return json
}
