import Parse from 'parse'

export default {
  namespaced: true,
  state: {
    curr: null,
    list: []
  },
  mutations: {
    setList(state, list) {
      state.list = list
    },
    setCurr(state, lang) {
      state.curr = lang
    }
  },
  actions: {
    setLang({ commit }, { lang }) {
      let Lang = Parse.Object.extend('Lang')
      let currLang = new Lang()
      currLang.id = lang.objectId
      localStorage.setItem('lego-web-lang', JSON.stringify(lang))
      commit('setCurr', lang.name)
    },
    fetchAllLang({ commit }) {
      let q = new Parse.Query('LEGO_Lang')
      return q.find().then(res => {
        commit('setList', res.map(item => item.toJSON()))
      })
    },
    fetchCustomLangRes({ commit }, params) {
      params = params || {}
      let objectId = params.objectId
      if (objectId) {
        let LangRes = Parse.Object.extend('CustomLangRes')
        let langRes = new LangRes()
        langRes.id = objectId
        return langRes.fetch()
      } else {
        let query = new Parse.Query('CustomLangRes')
        return query.find()
      }
    }
  }
}
