/*
 * 同步形式的store，设置好state中的值即可
 * namespaced为true，是为了避免store的module之间，getters、mutations、actions发生命名冲突
 */

// whatwg-fetch仅能在浏览器环境使用。

export default {
  namespaced: true,
  state: {
    tagdata: [
      {
        name: '标签1',
        value: '111'
      },
      {
        name: '标签2',
        value: '222'
      },
      {
        name: '标签3',
        value: '333'
      }
    ],
    selectedTag: [],
    searchKeyword: ''
  },
  mutations: {
    selectTag(state, data) {
      if (state.selectedTag.length > 0) {
        if (state.selectedTag.indexOf(data) > -1) {
          state.selectedTag.splice(state.selectedTag.indexOf(data), 1);
        } else {
          state.selectedTag.push(data);
        }
      } else {
        state.selectedTag.push(data);
      }

      console.log(state.selectedTag);
    },
    setSearchKeyword(state, data) {
      state.searchKeyword = data;
    }
  },
  // 浏览器环境才可以使用actions来获取数据，服务端应该用Node.js的方式获取数据后，通过mutations同步的把数据存入到store
  actions: {
    initTags({ commit, state }) {
      // 获取初始化标签
    }
  }
};
