export default {
  namespaced: true,
  state: {
    loginData: {}
  },
  mutations: {
    setLoginData(state, data) {
      if (data.code) {
        state.loginData = data;
      } else {
        localStorage.setItem('user_token', data.sessionToken);
        state.loginData = data;
      }
    }
  },
  actions: {
    getLogin({ commit }, { username, password }) {
      return fetch('http://itougu.jrj.com.cn/act/admins/login', {
        mode: 'cors',
        method: 'post',
        credentials: 'include',
        body: `username=${username}&password=${password}`
      })
        .then(res => {
          return res.json();
        })
        .then(body => {
          commit('setLoginData', body);
        })
        .catch((a, b, c) => {
          console.log(a);
        });
    },
    getLogout({ commit }) {
      return fetch('http://itougu.jrj.com.cn/act/admins/logout', {
        mode: 'cors',
        method: 'post',
        // credentials: 'include',
        headers: {
          'x-jrj-session-token': localStorage.getItem('user_token')
        }
      })
        .then(res => {
          return res.json();
        })
        .then(body => {
          commit('setLoginData', body);
        })
        .catch((a, b, c) => {
          console.log(a);
        });
    },
    getUserInfo({ commit }) {
      return fetch('http://itougu.jrj.com.cn/act/admins/me', {
        mode: 'cors',
        method: 'post',
        // credentials: 'include',
        headers: {
          'x-jrj-session-token': localStorage.getItem('user_token')
        }
      })
        .then(res => {
          return res.json();
        })
        .then(body => {
          commit('setLoginData', body);
        })
        .catch((a, b, c) => {
          console.log(a);
        });
    }
    /*  ,
    getLogout({ commit, state }, data) {
      $.ajax({
        type: 'post',
        url: 'http://itougu.jrj.com.cn/act/admins/logout',
        headers: {
          'x-jrj-session-token': localStorage.getItem('user_token')
        },
        dataType: 'json',
        xhrFields: {
          withCredentials: true
        },
        success: function(data) {
            commit('setLoginData', data);
        }
      });
    },
    getUserInfo({ commit, state }, data) {
      $.ajax({
        type: 'post',
        url: 'http://itougu.jrj.com.cn/act/admins/me',
        headers: {
          'x-jrj-session-token': localStorage.getItem('user_token')
        },
        /!* beforeSend: function(request) {
                    request.setRequestHeader("x-jrj-session-token", localStorage.getItem('user_token'));
                }, *!/
        dataType: 'json',
        xhrFields: {
          withCredentials: true
        },
        success: function(data) {
          console.log(data);
          console.log(localStorage.getItem('user_token'));
          if (data.code) {
            alert(data.error);
          } else {
            commit('setLoginData', data[0]);
          }
        }
      });
    } */
  }
};
